## libformfactor 0.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

project(formfactor VERSION 0.3.1 LANGUAGES CXX)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(PreventInSourceBuilds)

set(CMAKE_PROJECT_DESCRIPTION # for display in installer
    "libformfactor - computes Fourier shape transforms.")

## Options.

if(NOT DEFINED BUILD_SHARED_LIBS)
    option(BUILD_SHARED_LIBS "Build as shared library" ON)
endif()

## Compiler settings.

set(CMAKE_CXX_STANDARD 20)

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS}")
    set(MS_NOWARN "/wd4018 /wd4068 /wd4101 /wd4244 /wd4267 /wd4305 /wd4715 /wd4996")
    set(MS_D "-D_CRT_SECURE_NO_WARNINGS -D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} ${MS_NOWARN} ${MS_D}")
    set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin/$<CONFIG>)

else()
    option(WERROR "Treat warnings as errors" OFF)
    option(PEDANTIC "Compile with pedantic warnings" ON)
    if(PEDANTIC)
        add_compile_options(-pedantic -Wall)
    endif()
    if(WERROR)
        add_compile_options(-Werror)
    endif()

    add_compile_options(-fno-omit-frame-pointer)
    if (CMAKE_BUILD_TYPE MATCHES Debug)
        add_compile_options(-g)
    else()
        add_compile_options(-O3)
    endif()

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
endif()

## Dependences.

find_package(LibHeinz REQUIRED)
message(STATUS "LibHeinz: found=${LibHeinz_FOUND}, include_dirs=${LibHeinz_INCLUDE_DIR}, "
    "version=${LibHeinz_VERSION}")

## Source directory.

add_subdirectory(ff)

## Tests.

include(CTest)
add_subdirectory(test)

## CPack settings.

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "${formfactor_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${formfactor_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${formfactor_VERSION_PATCH}")
set(CPACK_SOURCE_GENERATOR "TGZ")
include(CPack)

## Config files.

include(CMakePackageConfigHelpers)
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/formfactorConfig.cmake"
    INSTALL_DESTINATION cmake
    NO_SET_AND_CHECK_MACRO
    NO_CHECK_REQUIRED_COMPONENTS_MACRO    )

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/formfactorConfigVersion.cmake"
    VERSION "${formfactor_VERSION}"
    COMPATIBILITY AnyNewerVersion    )

install(FILES
    "${PROJECT_BINARY_DIR}/formfactorConfig.cmake"
    "${PROJECT_BINARY_DIR}/formfactorConfigVersion.cmake"
    DESTINATION cmake)

## Export targets.

install(EXPORT formfactorTargets
  FILE formfactorTargets.cmake
  DESTINATION cmake)

export(EXPORT formfactorTargets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/formfactorTargets.cmake")

=== demo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

project(demo_using_formfactor VERSION 0.1.2 LANGUAGES CXX)

## Compiler settings.
option(WERROR "Treat warnings as errors" OFF)

set(CMAKE_CXX_STANDARD 17)
if(WIN32)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    message(STATUS "compiling for Windows")
else()
    option(PEDANTIC "Compile with pedantic warnings" ON)
    if(PEDANTIC)
        add_compile_options(-pedantic -Wall)
    endif()
endif()
add_compile_options(-O2)
if(WERROR)
    add_compile_options(-Werror)
endif()

## Dependencies
find_package(LibHeinz REQUIRED CONFIG)
find_package(formfactor REQUIRED CONFIG)

## Source
set(demos
    octahedron
    )

## Configure executable
foreach(app ${demos})
    add_executable(${app} "${app}.cpp")
    target_link_libraries(${app} formfactor)
endforeach()

=== ff/CMakeLists.txt ===
set(lib formfactor)
set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

file(GLOB src_files *.cpp)
set(api_files
    Box.h
    Face.h
    IBody.h
    Make.h
    Polyhedron.h
    Prism.h
    Topology.h
    )

add_library(${lib} ${src_files})

target_include_directories(${lib}
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>"
    "$<INSTALL_INTERFACE:include>"
    )
target_include_directories(${lib} PUBLIC "${LibHeinz_INCLUDE_DIR}")

set_target_properties(
    ${lib} PROPERTIES
    OUTPUT_NAME ${lib}
    VERSION ${PROJECT_VERSION})

install(
    TARGETS ${lib}
    EXPORT formfactorTargets
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION lib
    ARCHIVE DESTINATION lib)

install(
    FILES ${api_files}
    DESTINATION include/ff)

=== test/CMakeLists.txt ===
add_library(catch2 3rdparty/catch2.cpp)
target_include_directories(catch2 PRIVATE 3rdparty)

file(GLOB test_sources "*.cpp")

if (WIN32)
    add_compile_options(/wd4068 /wd4623 /wd4625 /wd4626 /wd4710 /wd4711 /wd4820 )
endif()

foreach(source_file ${test_sources})
    get_filename_component(base_name ${source_file} NAME_WE)
    add_executable(${base_name} "${source_file}" util/RunMultiQ.cpp)
    target_include_directories(${base_name}
        PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_SOURCE_DIR}" "${LibHeinz_INCLUDE_DIR}")
    target_link_libraries(${base_name} PRIVATE ${formfactor_LIBRARY} catch2)
    add_test(NAME ${base_name} COMMAND ${base_name})
endforeach(source_file)

=== devtools/test/Makefile ===
CC = g++ -ggdb -O3 -std=c++11 -Wall -I/G/ba/Core/FormFactors/ -I/G/ba/Core/Geometry -I/G/ba/Core/Tools -I/G/ba/Core/Samples -I/usr/include/eigen3

# LIBS=           -lm -lgslcblas -lgsl -lyaml-cpp

BIND = ./

all: $(BIND)runff

# source from BornAgain overwrites -lBornAgainCore, cf http://stackoverflow.com/questions/36667429
SRC = runff.cpp /G/ba/Core/FormFactors/FormFactorPolyhedron.cpp

DIAG = -D POLYHEDRAL_DIAGNOSTIC=ON

$(BIND)runff: $(SRC)
	$(CC) $(DIAG) -L../../../build/lib/ -l:_libBornAgainCore.so -o $(BIND)runff $(SRC)

=== debian/changelog ===
libformfactor (0.3.1-1) unstable; urgency=medium

  [ Roland Mas ]
  * Update debian/watch.

  [ Picca Frédéric-Emmanuel ]
  * New upstream version: 0.3.1
  * Trim trailing whitespace.
  * Remove field Section on binary package libformfactor0.3.0 that duplicates
    source.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 03 Aug 2023 11:08:31 +0200

libformfactor (0.3.0-3) unstable; urgency=medium

  * Fix installation paths for *.cmake files.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Jul 2023 12:52:42 +0200

libformfactor (0.3.0-2) unstable; urgency=medium

  * Fix dependency of -dev package.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Jul 2023 01:35:40 +0200

libformfactor (0.3.0-1) unstable; urgency=medium

  * Initial release.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Jul 2023 00:33:15 +0200

=== debian/control ===
Source: libformfactor
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Roland Mas <lolando@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libheinz-dev,
Standards-Version: 4.6.2
Homepage: https://jugit.fz-juelich.de/mlz/libformfactor
Vcs-Browser: https://salsa.debian.org/science-team/libformfactor
Vcs-Git: https://salsa.debian.org/science-team/libformfactor.git

Package: libformfactor-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libformfactor0.3.0 (= ${binary:Version}),
Description: computation of scattering form factors - development files
 A C++ library for the efficient computation of scattering form factors
 (Fourier shape transforms) of arbitrary polyhedra according to Wuttke
 [J Appl Cryst 54, 580-587 (2021)]


Package: libformfactor0.3.0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ library for the efficient computation of scattering form factors
 A C++ library for the efficient computation of scattering form factors
 (Fourier shape transforms) of arbitrary polyhedra according to Wuttke
 [J Appl Cryst 54, 580-587 (2021)]

=== debian/rules ===
#!/usr/bin/make -f

export CMAKE_OPTIONS := \
  -DCMAKE_PREFIX_PATH=/usr/share/cmake/heinz \
  -DCMAKE_BUILD_TYPE=Release

CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://jugit.fz-juelich.de/mlz/libformfactor/-/tags .*/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
